(******************************************)
(* Fonctions de conversions pour les char *)
(******************************************)

let int_to_char (c : int) : char =
  assert (c >= 0 && c <= 9);
  char_of_int (c + int_of_char '0');;

let charlist_of_string (s : string) : char list =
  let rec aux acc i =
    if i = 0 then
      acc
    else
      aux (s.[i-1]::acc) (i-1)
  in aux [] (String.length s);;

(*******************************)
(* Fonctions sur les ensembles *)
(*******************************)
let rec insere a l =
  assert false (* TODO *)
;;

let rec appartient a l =
  assert false (* TODO *)
;;

let rec egaux l1 l2 =
  assert false (* TODO *)
;;

let rec union l1 l2 =
  assert false (* TODO *)
;;

let rec intersection l1 l2 =
  assert false (* TODO *)
;;

(***************************)
(* Automates deterministes *)
(***************************)

type automate_det =
  {
    transitions : (char,int) Hashtbl.t array;
    init : int;
    final : int list;
  };;

let exemple_det : automate_det =
  let table i =
    let h = Hashtbl.create 7 in
    for j = 0 to 9 do
      Hashtbl.add h (int_to_char j) ((i*10+j) mod 7);
    done; h
  in {
      transitions = Array.init 7 (table);
      init = 0;
      final = [0];
    };;

let rec evalue_det (auto : automate_det) (mot : char list) : bool =
  assert false (* TODO *)
;;

(*******************************)
(* Automates non deterministes *)
(*******************************)

type automate =
  {
    transitions : (char, int list) Hashtbl.t array;
    init : int list;
    final : int list;
  };;

let exemple : automate =
  let table i =
    let h = Hashtbl.create 7 in
    for j = 0 to 9 do
      Hashtbl.add h (int_to_char j) [(i*10+j) mod 7];
    done; h
  in {
      transitions = Array.init 7 (table);
      init = [0];
      final = [0];
    };;

let rec evalue (auto : automate) (mot : char list) : bool =
  assert false (* TODO *)
;;

(************)
(* Emondage *)
(************)

let exemple_emond : automate =
  let table i =
    let h = Hashtbl.create 6 in
    begin match i with
    | 0 -> (Hashtbl.add h 'a' [3]; Hashtbl.add h 'b' [0])
    | 1 -> Hashtbl.add h 'a' [4]
    | 2 -> Hashtbl.add h 'b' [0;1]
    | 3 -> Hashtbl.add h 'b' [2]
    | 4 -> Hashtbl.add h 'a' [1]
    | 5 -> (Hashtbl.add h 'a' [3]; Hashtbl.add h 'b' [3])
    | _ -> assert false
    end; h
  in {
      transitions = Array.init 6 (table);
      init = [0];
      final = [3];
    };;

let rec accessibles_depuis (auto : automate) (etats : int list) : int list =
  (* Donne la liste des etats accessibles depuis un des etats de la liste donne en entree *)
  assert false (* TODO *)
;;

let accessibles (auto : automate) : int list =
  assert false (* TODO *)
;;

let coaccessibles (auto : automate) : int list =
  assert false (* TODO *)
;;

let emonde (auto : automate) : automate =
  assert false (* TODO *)
;;

(**************************)
(* transitions spontanees *)
(**************************)

type automate_eps =
  {
    transitions : (label, int list) Hashtbl.t array;
    mutable init : int list;
    mutable final : int list;
  }
and label = Epsilon | C of char;;

let exemple_eps : automate_eps =
  let auto = {
      transitions = Array.init 2 (fun _ -> Hashtbl.create 3);
      init = [0];
      final = [1];
    } in
  Hashtbl.add auto.transitions.(0) (C 'a') [0];
  Hashtbl.add auto.transitions.(1) (C 'b') [1];
  Hashtbl.add auto.transitions.(0) Epsilon [1];
  auto;;

let fermeture_arriere (auto : automate_eps) : unit =
  assert false (* TODO *)
;;
  
let remove_eps (auto : automate_eps) : automate =
  assert false (* TODO *)
;;
